Add npmrc config file to lf-infra-wrappers
[releng/global-jjb.git] / .jjb-test / expected-xml / github-python-tox-verify-master
index 31b825e..03e9893 100644 (file)
@@ -273,20 +273,56 @@ pipdeptree
 # which accompanies this distribution, and is available at
 # http://www.eclipse.org/legal/epl-v10.html
 ##############################################################################
-echo "---> tox-install.sh"
+echo "---> tox-run.sh"
 
 # Ensure we fail the job if any steps fail.
 # DO NOT set -u as virtualenv's activate script has unbound variables
 set -e -o pipefail
 
+ARCHIVE_TOX_DIR="$WORKSPACE/archives/tox"
+mkdir -p "$ARCHIVE_TOX_DIR"
+
 cd "$WORKSPACE/$TOX_DIR"
 
-if [ -n "$TOX_ENVS" ];
-then
-    tox -e "$TOX_ENVS"
+if [ -z "$TOX_ENVS" ]; then
+    TOX_ENVS=$(crudini --get tox.ini tox envlist)
+fi
+
+run_tox() {
+    local log_dir="$1"
+    local env="$2"
+
+    # Sleep a random 10 second interval to workaround tox sdist
+    # conflicts due to building in the same dist directory.
+    sleep $[ ( $RANDOM % 10 )  + 1 ]s
+
+    echo "-----> Running tox $env"
+    if ! tox -e $env > "$log_dir/tox-$env.log"; then
+        echo "$env" >> "$log_dir/failed-envs.log"
+    fi
+}
+
+TOX_ENVS=(${TOX_ENVS//,/ })
+if hash parallel 2>/dev/null; then
+    export -f run_tox
+    parallel --jobs 200% "run_tox $ARCHIVE_TOX_DIR {}" ::: ${TOX_ENVS[*]}
 else
-    tox
+    for env in "${TOX_ENVS[@]}"; do
+        run_tox "$ARCHIVE_TOX_DIR" "$env"
+    done
 fi
+
+if [ -f "$ARCHIVE_TOX_DIR/failed-envs.log" ]; then
+    failed_envs=($(cat "$ARCHIVE_TOX_DIR/failed-envs.log"))
+    for e in "${failed_envs[@]}"; do
+        echo "cat $ARCHIVE_TOX_DIR/tox-$e.log"
+        cat "$ARCHIVE_TOX_DIR/tox-$e.log"
+    done
+    echo "ERROR: Failed the following builds: ${failed_envs[*]}"
+    exit 1
+fi
+
+echo "Completed tox runs."
 </command>
     </hudson.tasks.Shell>
   </builders>
@@ -369,7 +405,7 @@ echo &quot;---&gt; create-netrc.sh&quot;
 # Ensure we fail the job if any steps fail.
 set -eu -o pipefail
 
-NEXUS_URL=&quot;${NEXUS_URL:-$NEXUSPROXY}&quot;
+NEXUS_URL=&quot;${NEXUSPROXY:-$NEXUS_URL}&quot;
 CREDENTIAL=$(xmlstarlet sel -N &quot;x=http://maven.apache.org/SETTINGS/1.0.0&quot; \
     -t -m &quot;/x:settings/x:servers/x:server[x:id='${SERVER_ID}']&quot; \
     -v x:username -o &quot;:&quot; -v x:password \
@@ -379,7 +415,7 @@ machine=$(echo &quot;$NEXUS_URL&quot; | awk -F/ '{print $3}')
 user=$(echo &quot;$CREDENTIAL&quot; | cut -f1 -d:)
 pass=$(echo &quot;$CREDENTIAL&quot; | cut -f2 -d:)
 
-echo &quot;machine $machine login $user password $pass&quot; &gt; ~/.netrc
+echo &quot;machine ${machine%:*} login $user password $pass&quot; &gt; ~/.netrc
 </command>
         </hudson.tasks.Shell>
         <hudson.tasks.Shell>
@@ -495,7 +531,7 @@ then
 
     echo &quot;WARNING: Logging server not set&quot;
 else
-    NEXUS_URL=&quot;${NEXUS_URL:-$NEXUSPROXY}&quot;
+    NEXUS_URL=&quot;${NEXUSPROXY:-$NEXUS_URL}&quot;
     NEXUS_PATH=&quot;${SILO}/${JENKINS_HOSTNAME}/${JOB_NAME}/${BUILD_NUMBER}&quot;
     BUILD_URL=&quot;${BUILD_URL}&quot;
 
@@ -567,5 +603,14 @@ rm ~/.netrc
       <user>test-credential</user>
     </com.cloudbees.jenkins.plugins.sshagent.SSHAgentBuildWrapper>
     <jenkins.plugins.openstack.compute.JCloudsOneOffSlave/>
+    <org.jenkinsci.plugins.configfiles.buildwrapper.ConfigFileBuildWrapper plugin="config-file-provider">
+      <managedFiles>
+        <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
+          <fileId>npmrc</fileId>
+          <targetLocation>$HOME/.npmrc</targetLocation>
+          <variable/>
+        </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
+      </managedFiles>
+    </org.jenkinsci.plugins.configfiles.buildwrapper.ConfigFileBuildWrapper>
   </buildWrappers>
 </project>